<?php
include_once ( WPT_PLUGIN_DIR."/includes/libs/phpquery.php" );

function wpt_articles_options_admin($self) {
  include_once(dirname(__file__)."/templates/admin-options.php");
}

function wpt_articles_response($params) {
  libxml_use_internal_errors(true);

  ksort($params);

  $request_query = array();
  foreach ($params as $param=>$value) {
    $request_query[] = $param."=".$value;
  }
  $request_query = implode("&", $request_query);
  
  $request = "http://www.articlesbase.com/find-articles.php?".$request_query;

  $response = wpt_get_response( $request, "Articles" );
  $_response = phpQuery::newDocument($response);
  $output = array();
  $_article_rows = $_response->find(".article_row");
  foreach( $_article_rows as $_article_row ) {
    $output[] = pq($_article_row)->find("div.title:first h3 a")->attr("href");
  }
  return $output;
}

function wpt_single_article_response($url) {
  $response = wpt_get_response( $url, "Articles" );
  $_article_data = phpQuery::newDocument($response);
  $output = array();
  $output['content'] = $_article_data->find(".article_pg:first .article_cnt .KonaBody")->html();
  $output['title'] = $_article_data->find(".article_pg:first h1:first")->html();
  $date_posted = trim($_article_data->find(".article_pg:first .article_data span:eq(1)")->text());
  $date_posted = str_replace( array("\n", "\r"), array(" ", " "), $date_posted );
  $date_posted = preg_replace( "/Posted:([^|]+).*/", "$1", $date_posted );
  $output['date_posted'] = trim($date_posted);
  $output['author'] = $_article_data->find(".article_pg:first .article_author:first .author_details:first strong:first a")->html();
  $author_url = $_article_data->find(".article_pg:first .article_author:first .author_details:first strong:first a")->attr("href");
  $output['author_url'] = preg_match('/http:\/\/[^\/]+\/.*/', $author_url) ? $author_url : 'http://www.articlesbase.com'.$author_url;
  $output = (object)$output;
  return $output;
}

function wpt_articles_post($params) {
  global $wpdb, $wpt;
  
  extract($params);
  
  include(dirname(__file__)."/wptm-options.php");
  $this_module_name = preg_replace("/^wptm\-/", "", basename(realpath(dirname(__FILE__))));
  
  if( isset($featured_image_module) && $featured_image_module == "{".$this_module_name."-fi}" ) {
    $featured_image_tt_index = array_search( "{".$featured_image_module_tag."}", $wpt_articles_template_tags );
  }

  if($keywords == "") {
    return send_module_errors("Articles", "[Keywords Empty] No keyword specified.");
  }
  
  $page = floor( $start/15 ) + 1;
  $last_post_number = $start - ( ($page - 1) * 15 );

  $template = $wpdb->get_var("SELECT content FROM {$wpt->db->table_name_templates} WHERE template_type = 'articles'");
  if($template == false || empty($template)) {
    return send_module_errors("Articles", "[Template Missing] Module Template was not found.");
  }

  $options = $wpt->options;

  $output = array();

  for($i = 0; $i < $count; $i++) {
    $article_response = wpt_articles_response(array(
                                        "q" => urlencode($keywords),
                                        "page" => $page,
                                      ));
    if(!empty($article_response["error"]))
      return $article_response;
    $count_this = ($count <= 15) ? $count : 15;
    
    $counter2 = 0;
    $counter1 = 1;

    if (!$article_response) {
      return send_module_errors("Articles", "[Request Failed] API request failed." );
    }

    if ( (count($article_response) < 1)) {
      return send_module_errors("Articles", "[Content Empty] No articles found for this keyword.");
    }
    
    foreach($article_response as $article_url) {
      if( $counter1 < $last_post_number ) {
        $counter1++;
        continue;
      }
      $counter1++;
      if ($counter2<$count_this) {
        $content = $template;
        $article_content = wpt_single_article_response($article_url);
        if( isset( $article_content->title ) ) {

          $content_search_tags = $wpt_articles_template_tags;
          $content_replace_tags = array(
            $keywords,
            (string)$article_content->title,
            (string)$article_content->content,
            (string)$article_content->author,
            (string)$article_content->author_url,
            (string)$article_content->date_posted,
          );
          
          $content = str_replace($content_search_tags, $content_replace_tags, $content);

          $post_data = array(
            "uid" => md5((string)$article_url),
            "title" => (string)$article_content->title,
            "content" => $content,
            "featured_image" => ( isset($featured_image_tt_index) && $featured_image_tt_index !== FALSE ) ? (string)$content_replace_tags[$featured_image_tt_index] : "",
          );
          array_push($output, $post_data);
        }
        $counter2++;
      }
    }
    $page++;
    $last_post_number = 0;
  }
  return $output;
}

function wpt_articles_init() {
  global $wpdb, $wpt;
  include(dirname(__file__)."/wptm-options.php");
  if(get_option("wpt_articles_module_template_installed") != "Yes") {
    $wpt->set_template("articles", $wpt_articles_default_module_template);
    update_option("wpt_articles_module_template_installed", "Yes");
  }
  if(get_option("wpt_articles_post_template_installed") != "Yes") {
    $wpt->set_template("post", $wpt_articles_default_post_template);
    update_option("wpt_articles_post_template_installed", "Yes");
  }
}
?>
